## Script (Python) "writeup_vote"
##parameters=REQUEST
##title=Vote for a writeup

action = REQUEST.get('action', None)

if action == 'add':
    obj = context.aq_parent.restrictedTraverse(REQUEST.get('path', None))
    type = REQUEST.get('type', 'firmlink')
    if type == 'firmlink':
        reciprocate = not not REQUEST.get('reciprocate', 0)
        allow = getattr(context, 'allow_firmlinks', 0)
        if allow:
            context.makeFirmlink(obj, reciprocate)
            msg = 'Firmlink successful.'
    elif type == 'softlink':
        allow = (getattr(context, 'allow_softlinks', 0) and getattr(obj, 'allow_softlinks', 0))
        if allow:
            context.makeSoftlink(obj)
            msg = 'Softlink successful.'
elif action == 'delete':
    for l in context.getSoftlinks():
        field_name = "softlink %s" % l.getPath()
        delme = not not REQUEST.get(field_name, 0)
        if delme:
            context.softlinks.deleteLink(l.getPath())
            try:
                obj = context.aq_parent.restrictedTraverse(l.getPath())
                obj.softlinks.deleteLink(context.getPath())
            except:
                pass
    for l in context.getFirmlinks():
        field_name = "firmlink %s" % l.getPath()
        delme = not not REQUEST.get(field_name, 0)
        if delme:
            context.firmlinks.deleteLink(l.getPath())
    msg = 'Delete successful.'

return context.node_links_form(portal_status_message=msg)
