## Script (Python) "Daily Housekeep"
##bind context=context
##bind namespace=_
##bind script=script
##bind subpath=
##parameters= 
##title=Daily Housekeeping
##

# This should only be done with someone with a Manage Portal permission

# * Reset daily votes and C!s
users = context.portal_membership.listMembers()
for u in users:
    context.portal_membership.dailyReset(u)

# * Update statistics
block = context.blocks.statistics

catalog = context.portal_catalog
nodes = len(catalog(Type = ('Node', )))
writeups = len(catalog(Type = ('Writeup', )))

block.manage_changeProperties(deltausers=len(users) - block.getProperty('users'),
                              users=len(users),
                              nodes=nodes,
                              deltawriteups=writeups - block.getProperty('writeups'),
                              writeups=writeups)

return 1